"use strict";
var __create = Object.create;
var __defProp = Object.defineProperty;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __export = (target, all) => {
  __markAsModule(target);
  for (var name in all)
    __defProp(target, name, {get: all[name], enumerable: true});
};
var __exportStar = (target, module2, desc) => {
  __markAsModule(target);
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  if (module2 && module2.__esModule)
    return module2;
  return __exportStar(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", {value: module2, enumerable: true}), module2);
};

// src/index.ts
__export(exports, {
  createExternalSubject: () => createExternalSubject,
  useExternalSubject: () => useExternalSubject
});

// src/create-external-subject.ts
function defaultShouldUpdate(a, b) {
  return !Object.is(a, b);
}
function createExternalSubject(options) {
  var _a;
  const shouldUpdate = (_a = options.shouldUpdate) != null ? _a : defaultShouldUpdate;
  let cache = options.read();
  const listeners = new Set();
  let request;
  const requestUpdate = () => {
    if (shouldUpdate(cache, options.read())) {
      if (request) {
        request.alive = false;
      }
      request = {
        promise: Promise.resolve().then(() => {
          if (request == null ? void 0 : request.alive) {
            request = void 0;
            cache = options.read();
            listeners.forEach((listener) => {
              listener();
            });
          }
        }),
        alive: true
      };
    }
  };
  const subscribe = (handler) => {
    listeners.add(handler);
    let unsubscribe;
    if (options.lazySubscribe && options.subscribe && listeners.size === 1) {
      const unsub = options.subscribe(requestUpdate);
      if (unsub) {
        unsubscribe = unsub;
      }
    }
    return () => {
      listeners.delete(handler);
      unsubscribe == null ? void 0 : unsubscribe();
    };
  };
  if (!options.lazySubscribe && options.subscribe) {
    options.subscribe(requestUpdate);
  }
  return {
    subscribe,
    shouldUpdate,
    requestUpdate,
    getRequest: () => request,
    getCachedValue: () => cache,
    getCurrentValue: options.read
  };
}

// src/use-external-subject.ts
var react_hooks = __toModule(require("@lyonph/react-hooks"));
function useExternalSubject(subject, suspense = false) {
  const forceUpdate = react_hooks.useForceUpdate();
  react_hooks.useIsomorphicEffect(() => {
    const unsubscribe = subject.subscribe(forceUpdate);
    return unsubscribe;
  }, [subject]);
  react_hooks.useIsomorphicEffect(() => {
    if (!subject.getRequest()) {
      subject.requestUpdate();
      const ongoing2 = subject.getRequest();
      if (ongoing2) {
        forceUpdate();
        return void 0;
      }
    }
    const timeout = setTimeout(() => {
      const afterOngoing = subject.getRequest();
      if (afterOngoing) {
        forceUpdate();
        return;
      }
      subject.requestUpdate();
      const currentOngoing = subject.getRequest();
      if (currentOngoing) {
        forceUpdate();
      }
    });
    return () => {
      clearTimeout(timeout);
    };
  });
  const cached = subject.getCachedValue();
  const ongoing = subject.getRequest();
  if (ongoing) {
    if (suspense) {
      throw ongoing.promise;
    }
    return cached;
  }
  subject.requestUpdate();
  const current = subject.getRequest();
  if (current) {
    if (suspense) {
      throw current.promise;
    }
    return cached;
  }
  return subject.getCurrentValue();
}
//# sourceMappingURL=react-external-subject.development.js.map
